#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>
#include <cstring>
#include "src/tinycrc.h"



int main()
{
    uint8_t* buffer = (uint8_t*)malloc(32);

    sprintf((char*)buffer, "Hello %s!", "World");

    uint32_t crc32 = tinycrc_crc32(buffer, 32);
    uint16_t crc16 = tinycrc_crc16(buffer, 32);
    uint8_t crc8 = tinycrc_crc8(buffer, 32);

    printf("%-32s | crc32 | %08x\n", (char*)buffer, crc32);
    printf("%-32s | crc16 |     %04x\n", (char*)buffer, crc16);
    printf("%-32s | crc8  |       %02x\n", (char*)buffer, crc8);

    sprintf((char*)buffer, "Hello %s!", "Worlds");

    crc32 = tinycrc_crc32(buffer, 32);
    crc16 = tinycrc_crc16(buffer, 32);
    crc8 = tinycrc_crc8(buffer, 32);

    printf("%-32s | crc32 | %08x\n", (char*)buffer, crc32);
    printf("%-32s | crc16 |     %04x\n", (char*)buffer, crc16);
    printf("%-32s | crc8  |       %02x\n", (char*)buffer, crc8);

    sprintf((char*)buffer, "%s %d", "foobarxyzzy", 42);

    crc32 = tinycrc_crc32(buffer, 32);
    crc16 = tinycrc_crc16(buffer, 32);
    crc8 = tinycrc_crc8(buffer, 32);

    printf("%-32s | crc32 | %08x\n", (char*)buffer, crc32);
    printf("%-32s | crc16 |     %04x\n", (char*)buffer, crc16);
    printf("%-32s | crc8  |       %02x\n", (char*)buffer, crc8);

    free(buffer);


}
